unit Unit1;
{ Refer to "ReadMeFirst.txt" }
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    cmdCreateGlobalatom: TButton;
    cmdRemoveGlobalAtom: TButton;
    cmdCloseDemo: TButton;
    procedure cmdCreateGlobalatomClick(Sender: TObject);
    procedure cmdRemoveGlobalAtomClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmdCloseDemoClick(Sender: TObject);
  private
    { Private declarations }
    function FindMyAtom:boolean ;
    procedure ToggleCommandButtons ;
  public
    { Public declarations }
  end;

const
  MyAtomName: PChar = 'Kevin' ;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function TForm1.FindMyAtom:boolean ;
var
  MyAtom: TAtom ;
begin
  MyAtom := GlobalFindAtom(MyAtomName) ;
  Result := MyAtom <> 0 ;
end;

procedure TForm1.cmdCreateGlobalatomClick(Sender: TObject);
var
  MyAtom: TAtom ;
begin
  if GlobalAddAtom(MyAtomName) <> 0 then
    ToggleCommandButtons 
  else
    MessageDlg('Failed to create atom',mtInformation,[mbOk],0) ;
end;

procedure TForm1.cmdRemoveGlobalAtomClick(Sender: TObject);
var
  MyAtom: TAtom ;
begin
  MyAtom := GlobalFindAtom(MyAtomName) ;
  if MyAtom <> 0 then
    GlobalDeleteAtom(MyAtom) ;

  ToggleCommandButtons ;
end;

procedure TForm1.ToggleCommandButtons ;
begin

  if FindMyAtom then
  begin
    cmdRemoveGlobalAtom.Enabled := True ;
    cmdCreateGlobalatom.Enabled := False ;
  end else
  begin
    cmdRemoveGlobalAtom.Enabled := False ;
    cmdCreateGlobalatom.Enabled := True ;
  end ;
end ;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ToggleCommandButtons ;
end;

procedure TForm1.cmdCloseDemoClick(Sender: TObject);
begin
  Close ;
end;

end.
